#include <stdio.h>
#include <iostream>
#include <cstring>
#include <sys/mman.h>
#include <unistd.h>
extern "C" {
	#include <castor.h>
	#include <castor_extra.h>
}
using namespace std;

int main(int argc, char* argv[]) {
	printf("libcastor test app 0.2 by orkie\n\n");
	if(lc_init() < 0) {
		printf("Could not start libcastor\n");
		return 1;
	}

	lc_setlayer(1, true, false, false, false, PTRGB565);
	lc_palette[1][0] = RGB24TO16(0xff,0x00,0x00);
	lc_palette[1][1] = RGB24TO16(0x00,0xff,0x00);
	lc_setpalette(1);
	int i;
	for(i = 0 ; i < 240*320 ; i++) {
		lc_8bpp_fb1[i] = (i%2?1:0);
	}

	int run = 1;
	while(run) {
		if(lc_getbuttons() & BTN_A) { // switch to 240x320 mode
			printf("A pressed\n");
			lc_screensize(240, 320);
			lc_layerpos(0, 0, 0, 239, 319);
		}
		if(lc_getbuttons() & BTN_X) { // switch to 320x240 mode
			printf("X pressed\n");
			lc_screensize(320, 240);
			lc_layerpos(0, 0, 0, 319, 239);
		}
		if(lc_getbuttons() & BTN_B) { // exit
			printf("B pressed\n");
			run = 0;
		}
		if(lc_getbuttons() & BTN_Y) { // change palette
			lc_palette[1][0] = RGB24TO16(0xff,0x00,0xff);
			lc_palette[1][1] = RGB24TO16(0x00,0x00,0xff);
			lc_setpalette(1);
		}
	}

	lc_exit();
	return 0;
}
	

